ctdb: Drop configuration file ctdbd.conf
[samba.git] / ctdb / config / functions
index 4290bfa841ff5fde50fa415e33101cdd22c38ce5..30afcdec9623eb23a27073756612cf48f33870cc 100755 (executable)
@@ -2,86 +2,88 @@
 
 # utility functions for ctdb event scripts
 
-[ -z "$CTDB_VARDIR" ] && {
-    if [ -d "/var/lib/ctdb" ] ; then
-       export CTDB_VARDIR="/var/lib/ctdb"
-    else
-       export CTDB_VARDIR="/var/ctdb"
-    fi
-}
-[ -z "$CTDB_ETCDIR" ] && {
-    export CTDB_ETCDIR="/etc"
-}
+if [ -z "$CTDB_BASE" ] ; then
+    echo 'CTDB_BASE unset in CTDB functions file'
+    exit 1
+fi
+export CTDB_BASE
 
-#######################################
-# pull in a system config file, if any
-_loadconfig() {
+# CTDB_VARDIR is used elsewhere
+# shellcheck disable=SC2034
+CTDB_VARDIR="/usr/local/var/lib/ctdb"
 
-    if [ -z "$1" ] ; then
-       foo="${service_config:-${service_name}}"
-       if [ -n "$foo" ] ; then
-           loadconfig "$foo"
-           return
-       fi
-    fi
+CTDB="${CTDB:-/usr/local/bin/ctdb}"
 
-    if [ "$1" != "ctdb" ] ; then
-       loadconfig "ctdb"
-    fi
+# Only (and always) override these variables in test code
 
-    if [ -z "$1" ] ; then
-       return
-    fi
+if [ -z "$CTDB_SCRIPT_VARDIR" ] ; then
+    CTDB_SCRIPT_VARDIR="/usr/local/var/lib/ctdb/scripts"
+fi
 
-    if [ -f $CTDB_ETCDIR/sysconfig/$1 ]; then
-       . $CTDB_ETCDIR/sysconfig/$1
-    elif [ -f $CTDB_ETCDIR/default/$1 ]; then
-       . $CTDB_ETCDIR/default/$1
-    elif [ -f $CTDB_BASE/sysconfig/$1 ]; then
-       . $CTDB_BASE/sysconfig/$1
-    fi
+if [ -z "$CTDB_SYS_ETCDIR" ] ; then
+    CTDB_SYS_ETCDIR="/etc"
+fi
+
+if [ -z "$CTDB_HELPER_BINDIR" ] ; then
+    CTDB_HELPER_BINDIR="/usr/local/libexec/ctdb"
+fi
+
+#######################################
+# pull in a system config file, if any
 
-    if [ "$1" = "ctdb" ] ; then
-       _config="${CTDB_BASE}/ctdbd.conf"
-       if [ -r "$_config" ] ; then
-           . "$_config"
+load_system_config ()
+{
+       if [ -z "$1" ] ; then
+               return
        fi
-    fi
-}
 
-loadconfig () {
-    _loadconfig "$@"
+       if [ -f "${CTDB_SYS_ETCDIR}/sysconfig/$1" ]; then
+               . "${CTDB_SYS_ETCDIR}/sysconfig/$1"
+       elif [ -f "${CTDB_SYS_ETCDIR}/default/$1" ]; then
+               . "${CTDB_SYS_ETCDIR}/default/$1"
+       fi
 }
 
-##############################################################
-
-# CTDB_SCRIPT_DEBUGLEVEL can be overwritten by setting it in a
-# configuration file.
-debug ()
+# load_script_options [ component script ]
+#   script is an event script name relative to a component
+#   component is currently ignored
+load_script_options ()
 {
-    if [ ${CTDB_SCRIPT_DEBUGLEVEL:-2} -ge 4 ] ; then
-       # If there are arguments then echo them.  Otherwise expect to
-       # use stdin, which allows us to pass lots of debug using a
-       # here document.
-       if [ -n "$1" ] ; then
-           echo "DEBUG: $*"
+       if [ $# -eq 2 ] ; then
+               _script="$2"
+       elif [ $# -eq 0  ] ; then
+               _script=""
        else
-           sed -e 's@^@DEBUG: @'
+               die "usage: load_script_options [ component script ]"
        fi
-    else
-       if [ -z "$1" ] ; then
-           cat >/dev/null
+
+       _options="${CTDB_BASE}/script.options"
+
+       if [ -r "$_options" ] ; then
+               . "$_options"
+       fi
+
+       if [ -n "$_script" ] ; then
+               _s="${CTDB_BASE}/events.d/${_script}"
+       else
+               _s="${0%.script}"
+       fi
+       _options="${_s}.options"
+
+       if [ -r "$_options" ] ; then
+               . "$_options"
        fi
-    fi
 }
 
+##############################################################
+
 die ()
 {
     _msg="$1"
     _rc="${2:-1}"
 
-    echo "$_msg"
-    exit $_rc
+    echo "$_msg" >&2
+    exit "$_rc"
 }
 
 # Log given message or stdin to either syslog or a CTDB log file
@@ -95,7 +97,7 @@ script_log ()
            if [ -n "$CTDB_LOGGING" ] ; then
                _file="${CTDB_LOGGING#file:}"
            else
-               _file="/var/log/log.ctdb"
+               _file="/usr/local/var/log/log.ctdb"
            fi
            {
                if [ -n "$*" ] ; then
@@ -108,7 +110,7 @@ script_log ()
        *)
            # Handle all syslog:* variants here too.  There's no tool to do
            # the lossy things, so just use logger.
-           logger -t "ctdbd: ${_tag}" $*
+           logger -t "ctdbd: ${_tag}" "$@"
            ;;
     esac
 }
@@ -149,16 +151,18 @@ ctdb_check_args ()
 # determine on what type of system (init style) we are running
 detect_init_style()
 {
-    # only do detection if not already set:
-    [ -z "$CTDB_INIT_STYLE" ] || return
+       # only do detection if not already set:
+       if [ -n "$CTDB_INIT_STYLE" ] ; then
+               return
+       fi
 
-    if [ -x /sbin/startproc ]; then
-        CTDB_INIT_STYLE="suse"
-    elif [ -x /sbin/start-stop-daemon ]; then
-        CTDB_INIT_STYLE="debian"
-    else
-        CTDB_INIT_STYLE="redhat"
-    fi
+       if [ -x /sbin/startproc ]; then
+               CTDB_INIT_STYLE="suse"
+       elif [ -x /sbin/start-stop-daemon ]; then
+               CTDB_INIT_STYLE="debian"
+       else
+               CTDB_INIT_STYLE="redhat"
+       fi
 }
 
 ######################################################
@@ -177,10 +181,12 @@ _service ()
       $_nice /sbin/service "$_service_name" "$_op"
   elif [ -x /usr/sbin/service ]; then
       $_nice /usr/sbin/service "$_service_name" "$_op"
-  elif [ -x $CTDB_ETCDIR/init.d/$_service_name ]; then
-      $_nice $CTDB_ETCDIR/init.d/$_service_name "$_op"
-  elif [ -x $CTDB_ETCDIR/rc.d/init.d/$_service_name ]; then
-      $_nice $CTDB_ETCDIR/rc.d/init.d/$_service_name "$_op"
+  elif [ -x /bin/systemctl ]; then
+      $_nice /bin/systemctl "$_op" "$_service_name"
+  elif [ -x "${CTDB_SYS_ETCDIR}/init.d/${_service_name}" ]; then
+      $_nice "${CTDB_SYS_ETCDIR}/init.d/${_service_name}" "$_op"
+  elif [ -x "${CTDB_SYS_ETCDIR}/rc.d/init.d/${_service_name}" ]; then
+      $_nice "${CTDB_SYS_ETCDIR}/rc.d/init.d/${_service_name}" "$_op"
   fi
 }
 
@@ -201,15 +207,66 @@ nice_service()
 ######################################################
 # Cached retrieval of PNN from local node.  This never changes so why
 # open a client connection to the server each time this is needed?
-# This sets $pnn - this avoid an unnecessary subprocess.
 ctdb_get_pnn ()
 {
-    _pnn_file="$CTDB_VARDIR/state/my-pnn"
+    _pnn_file="${CTDB_SCRIPT_VARDIR}/my-pnn"
     if [ ! -f "$_pnn_file" ] ; then
-       ctdb pnn | sed -e 's@.*:@@' >"$_pnn_file"
+       $CTDB pnn >"$_pnn_file"
+    fi
+
+    cat "$_pnn_file"
+}
+
+# Cached retrieval of private IP address from local node.  This never
+# changes.
+ctdb_get_ip_address ()
+{
+    _ip_addr_file="${CTDB_SCRIPT_VARDIR}/my-ip-address"
+    if [ ! -f "$_ip_addr_file" ] ; then
+       $CTDB -X nodestatus |
+           awk -F '|' 'NR == 2 { print $3 }' >"$_ip_addr_file"
     fi
 
-    read pnn <"$_pnn_file"
+    # ip_address is used by caller
+    # shellcheck disable=SC2034
+    cat "$_ip_addr_file"
+}
+
+# Cached retrieval of database options for use by event scripts.
+#
+# If the variables are already set then they should not be overwritten
+# - this should only happen during event script testing.
+ctdb_get_db_options ()
+{
+       _db_opts_file="${CTDB_SCRIPT_VARDIR}/db_options.cache"
+
+       if [ ! -f "$_db_opts_file" ] ; then
+               {
+                       ctdb_translate_option "database" \
+                                             "volatile database directory" \
+                                             "CTDB_DBDIR"
+                       ctdb_translate_option "database" \
+                                             "persistent database directory" \
+                                             "CTDB_DBDIR_PERSISTENT"
+                       ctdb_translate_option "database" \
+                                             "state database directory" \
+                                             "CTDB_DBDIR_STATE"
+               } >"$_db_opts_file"
+       fi
+
+       . "$_db_opts_file"
+}
+
+ctdb_translate_option ()
+{
+       _section="$1"
+       _opt="$2"
+       _variable="$3"
+
+       # ctdb-config already prints an error if something goes wrong
+       _t=$("${CTDB_HELPER_BINDIR}/ctdb-config" get "$_section" "$_opt") || \
+               exit $?
+       echo "${_variable}=\"${_t}\""
 }
 
 ######################################################
@@ -246,401 +303,14 @@ program_stack_traces ()
 
     _count=1
     for _pid in $(pidof "$_prog") ; do
-       [ $_count -le $_max ] || break
+       [ "$_count" -le "$_max" ] || break
 
        # Do this first to avoid racing with process exit
        _stack=$(get_proc "${_pid}/stack" 2>/dev/null)
        if [ -n "$_stack" ] ; then
            echo "Stack trace for ${_prog}[${_pid}]:"
            echo "$_stack"
-           _count=$(($_count + 1))
-       fi
-    done
-}
-
-######################################################
-# Check that an RPC service is healthy -
-# this includes allowing a certain number of failures
-# before marking the NFS service unhealthy.
-#
-# usage: nfs_check_rpc_service SERVICE_NAME [ triple ...]
-#
-# each triple is a set of 3 arguments: an operator, a 
-# fail count limit and an action string.
-#
-# For example:
-#
-#      nfs_check_rpc_service "lockd" \
-#          -ge 15 "verbose restart unhealthy" \
-#          -eq 10 "restart:bs"
-#
-# says that if lockd is down for 15 iterations then do
-# a verbose restart of lockd and mark the node unhealthy.
-# Before this, after 10 iterations of failure, the
-# service is restarted silently in the background.
-# Order is important: the number of failures need to be
-# specified in reverse order because processing stops
-# after the first condition that is true.
-######################################################
-nfs_check_rpc_service ()
-{
-    _prog_name="$1" ; shift
-
-    if _nfs_check_rpc_common "$_prog_name" ; then
-       return
-    fi
-
-    while [ -n "$3" ] ; do
-       if _nfs_check_rpc_action "$1" "$2" "$3" ; then
-           break
-       fi
-       shift 3
-    done
-}
-
-# The new way of doing things...
-nfs_check_rpc_services ()
-{
-    # Files must end with .check - avoids editor backups, RPM fu, ...
-    for _f in "${CTDB_BASE}/nfs-rpc-checks.d/"[0-9][0-9].*.check ; do
-       _t="${_f%.check}"
-       _prog_name="${_t##*/[0-9][0-9].}"
-
-       # If $_prog_name contains '@' then the bit after it is the
-       # address family.
-       _family="${_prog_name#*@}"
-       if [ "$_family" = "$_prog_name" ] ; then
-           _family=""
-       else
-           _prog_name="${_prog_name%@*}"
-       fi
-
-       if _nfs_check_rpc_common "$_prog_name" "$_family" ; then
-           # This RPC service is up, check next service...
-           continue
-       fi
-
-       # Check each line in the file in turn until one of the limit
-       # checks is hit...
-       while read _cmp _lim _rest ; do
-           # Skip comments
-           case "$_cmp" in
-               \#*) continue ;;
-           esac
-
-           if _nfs_check_rpc_action "$_cmp" "$_lim" "$_rest" ; then
-               # Limit was hit on this line, no further checking...
-               break
-           fi
-       done <"$_f"
-    done
-}
-
-_nfs_check_rpc_common ()
-{
-    _prog_name="$1"
-    _family="$2"
-
-    # Some platforms don't have separate programs for all services.
-    case "$_prog_name" in
-       statd)
-           type "rpc.${_prog_name}" >/dev/null 2>&1 || return 0
-    esac
-
-    case "$_prog_name" in
-       nfsd)
-           _rpc_prog=nfs
-           _version=3
-           ;;
-       mountd)
-           _rpc_prog=mountd
-           _version=1
-           ;;
-       rquotad)
-           _rpc_prog=rquotad
-           _version=1
-           ;;
-       lockd)
-           _rpc_prog=nlockmgr
-           _version=4
-           ;;
-       statd)
-           _rpc_prog=status
-           _version=1
-           ;;
-       *)
-           echo "Internal error: unknown RPC program \"$_prog_name\"."
-           exit 1
-    esac
-
-    _service_name="nfs_${_prog_name}${_family:+_}${_family}"
-
-    if ctdb_check_rpc "$_rpc_prog" "$_version" "$_family" >/dev/null ; then
-       ctdb_counter_init "$_service_name"
-       return 0
-    fi
-
-    ctdb_counter_incr "$_service_name"
-
-    return 1
-}
-
-_nfs_check_rpc_action ()
-{
-    _cmp="$1"
-    _limit="$2"
-    _actions="$3"
-
-    if ctdb_check_counter "quiet" "$_cmp" "$_limit" "$_service_name" ; then
-       return 1
-    fi
-
-    for _action in $_actions ; do
-       case "$_action" in
-           verbose)
-               echo "ERROR: $ctdb_check_rpc_out"
-               ;;
-           restart)
-               _nfs_restart_rpc_service "$_prog_name"
-               ;;
-           restart:b)
-               _nfs_restart_rpc_service "$_prog_name" true
-               ;;
-           unhealthy)
-               exit 1
-               ;;
-           *)
-               echo "Internal error: unknown action \"$_action\"."
-               exit 1
-       esac
-    done
-
-    return 0
-}
-
-_nfs_restart_rpc_service ()
-{
-    _prog_name="$1"
-    _background="${2:-false}"
-
-    if $_background ; then
-       _maybe_background="background_with_logging"
-    else
-       _maybe_background=""
-    fi
-
-    _p="rpc.${_prog_name}"
-
-    case "$_prog_name" in
-       nfsd)
-           echo "Trying to restart NFS service"
-           $_maybe_background startstop_nfs restart
-           ;;
-       mountd)
-           echo "Trying to restart $_prog_name [${_p}]"
-           killall -q -9 "$_p"
-           nfs_dump_some_threads "$_p"
-           $_maybe_background $_p $RPCMOUNTDOPTS \
-                              ${MOUNTD_PORT:+-p} $MOUNTD_PORT
-           ;;
-       rquotad)
-           echo "Trying to restart $_prog_name [${_p}]"
-           killall -q -9 "$_p"
-           nfs_dump_some_threads "$_p"
-           $_maybe_background $_p ${RQUOTAD_PORT:+-p} $RQUOTAD_PORT
-           ;;
-       lockd)
-           echo "Trying to restart lock manager service"
-           $_maybe_background startstop_nfslock restart
-           ;;
-       statd)
-           echo "Trying to restart $_prog_name [${_p}]"
-           killall -q -9 "$_p"
-           nfs_dump_some_threads "$_p"
-           $_maybe_background $_p \
-               ${STATD_HOSTNAME:+-n} $STATD_HOSTNAME \
-               ${STATD_PORT:+-p} $STATD_PORT \
-               ${STATD_OUTGOING_PORT:+-o} $STATD_OUTGOING_PORT
-           ;;
-       *)
-           echo "Internal error: unknown RPC program \"$_prog_name\"."
-           exit 1
-    esac
-}
-
-######################################################
-# Check the health of NFS services
-#
-# Use .check files in given directory.
-# Default is "${CTDB_BASE}/nfs-checks.d/"
-######################################################
-nfs_check_services ()
-{
-    _dir="${1:-${CTDB_NFS_CHECKS_DIR:-${CTDB_BASE}/nfs-checks.d}}"
-
-    # Files must end with .check - avoids editor backups, RPM fu, ...
-    for _f in "$_dir"/[0-9][0-9].*.check ; do
-       _t="${_f%.check}"
-       _progname="${_t##*/[0-9][0-9].}"
-
-       nfs_check_service "$_progname" <"$_f"
-    done
-}
-
-######################################################
-# Check the health of an NFS service
-#
-# $1 - progname, passed to rpcinfo (looked up in /etc/rpc)
-#
-# Reads variables from stdin
-#
-# Variables are:
-#
-# * family             - "tcp" or "udp" or space separated list
-#                        default: tcp
-# * version            - optional, RPC service version number
-#                        default is to omit to check for any version
-# * unhealthy_after    - number of check fails before unhealthy
-#                        default: 1
-# * restart_every      - number of check fails before restart
-#                        default: 0, meaning no restart
-# * service_stop_cmd   - command to stop service
-#                        default: no default, must be provided if
-#                                 restart_every > 0
-# * service_start_cmd  - command to start service
-#                        default: no default, must be provided if
-#                                 restart_every > 0
-# * service_debug_cmd  - command to debug a service after trying to stop it;
-#                        for example, it can be useful to print stack
-#                        traces of threads that have not exited, since
-#                        they may be stuck doing I/O;
-#                        no default, see also function program_stack_traces()
-#
-# Quoting in values is not preserved
-#
-######################################################
-nfs_check_service ()
-{
-    _progname="$1"
-
-    (
-       # Subshell to restrict scope variables...
-
-       # Defaults
-       family="tcp"
-       version=""
-       unhealthy_after=1
-       restart_every=0
-       service_stop_cmd=""
-       service_start_cmd=""
-       service_debug_cmd=""
-
-       # Eval line-by-line.  Expands variable references in values.
-       # Also allows variable name checking, which seems useful.
-       while read _line ; do
-           case "$_line" in
-               \#*|"") : ;; # Ignore comments, blank lines
-
-               family=*|version=*|\
-               unhealthy_after=*|restart_every=*|\
-               service_stop_cmd=*|service_start_cmd=*|\
-               service_debug_cmd=*)
-
-                   eval "$_line"
-                   ;;
-               *)
-                   echo "ERROR: Unknown variable for ${_progname}: ${_line}"
-                   exit 1
-           esac
-       done
-
-       _service_name="nfs_${_progname}"
-
-       if nfs_check_rpcinfo \
-              "$_progname" "$version" "$family" >/dev/null ; then
-           if [ $unhealthy_after -ne 1 -o $restart_every -ne 0 ] ; then
-               ctdb_counter_init "$_service_name"
-           fi
-           exit 0
-       fi
-
-       ctdb_counter_incr "$_service_name"
-       _failcount=$(ctdb_counter_get "$_service_name")
-
-       _unhealthy=false
-       if [ $unhealthy_after -gt 0 ] ; then
-           if [ $_failcount -ge $unhealthy_after ] ; then
-               _unhealthy=true
-               echo "ERROR: $ctdb_check_rpc_out"
-           fi
-       fi
-
-       if [ $restart_every -gt 0 ] ; then
-           if [ $(($_failcount % $restart_every)) -eq 0 ] ; then
-               if ! $_unhealthy ; then
-                   echo "WARNING: $ctdb_check_rpc_out"
-               fi
-               nfs_restart_service
-           fi
-       fi
-
-       if $_unhealthy ; then
-           exit 1
-       fi
-
-       return 0
-    ) || exit 1
-}
-
-# Uses: stop_service, start_service, debug_stuck_threads
-nfs_restart_service ()
-{
-    if [ -z "$service_stop_cmd" -o -z "$service_start_cmd" ] ; then
-       die "ERROR: Can not restart service \"${_progname}\" without corresponding service_start_cmd/service_stop_cmd settings"
-    fi
-
-    echo "Trying to restart service \"${_progname}\"..."
-    # Using eval means variables can contain semicolon separated commands
-    eval "$service_stop_cmd"
-    if [ -n "$service_debug_cmd" ] ; then
-       eval "$service_debug_cmd"
-    fi
-    background_with_logging eval "$service_start_cmd"
-}
-
-######################################################
-# Check an RPC service with rpcinfo
-######################################################
-ctdb_check_rpc ()
-{
-    _progname="$1"        # passed to rpcinfo (looked up in /etc/rpc)
-    _version="$2"         # optional, not passed if empty/unset
-    _family="${3:-tcp}"   # optional, default is "tcp"
-
-    _localhost="${CTDB_RPCINFO_LOCALHOST:-127.0.0.1}"
-
-    if ! ctdb_check_rpc_out=$(rpcinfo -T $_family $_localhost \
-                                     $_progname $_version 2>&1) ; then
-       ctdb_check_rpc_out="$_progname failed RPC check:
-$ctdb_check_rpc_out"
-       echo "$ctdb_check_rpc_out"
-       return 1
-    fi
-}
-
-nfs_check_rpcinfo ()
-{
-    _progname="$1"        # passed to rpcinfo (looked up in /etc/rpc)
-    _versions="$2"        # optional, space separated, not passed if empty/unset
-    _families="${3:-tcp}" # optional, space separated, default is "tcp"
-
-    for _family in $_families ; do
-       if [ -n "$_versions" ] ; then
-           for _version in $_versions ; do
-               ctdb_check_rpc $_progname $_version $_family || return $?
-           done
-       else
-           ctdb_check_rpc $_progname "" $_family || return $?
+           _count=$((_count + 1))
        fi
     done
 }
@@ -649,7 +319,9 @@ nfs_check_rpcinfo ()
 # Ensure $service_name is set
 assert_service_name ()
 {
-    [ -n "$service_name" ] || die "INTERNAL ERROR: \$service_name not set"
+       # service_name is set by the event script
+       # shellcheck disable=SC2154
+       [ -n "$service_name" ] || die "INTERNAL ERROR: \$service_name not set"
 }
 
 ######################################################
@@ -687,93 +359,60 @@ ctdb_check_directories()
 # usage: ctdb_check_tcp_ports <ports...>
 ######################################################
 
-# This flag file is created when a service is initially started.  It
-# is deleted the first time TCP port checks for that service succeed.
-# Until then ctdb_check_tcp_ports() prints a more subtle "error"
-# message if a port check fails.
-_ctdb_check_tcp_common ()
-{
-    assert_service_name
-    _ctdb_service_started_file="$ctdb_fail_dir/$service_name.started"
-}
-
-ctdb_check_tcp_init ()
-{
-    _ctdb_check_tcp_common
-    mkdir -p "${_ctdb_service_started_file%/*}" # dirname
-    touch "$_ctdb_service_started_file"
-}
-
 # Check whether something is listening on all of the given TCP ports
 # using the "ctdb checktcpport" command.
 ctdb_check_tcp_ports()
 {
-    if [ -z "$1" ] ; then
-       echo "INTERNAL ERROR: ctdb_check_tcp_ports - no ports specified"
-       exit 1
-    fi
-
-    for _p ; do  # process each function argument (port)
-       _cmd="ctdb checktcpport $_p"
-       _out=$($_cmd 2>&1)
-       _ret=$?
-       case "$_ret" in
-           0)
-               _ctdb_check_tcp_common
-               if [ ! -f "$_ctdb_service_started_file" ] ; then
-                   echo "ERROR: $service_name tcp port $_p is not responding"
-                   debug "\"ctdb checktcpport $_p\" was able to bind to port"
-               else
-                   echo "INFO: $service_name tcp port $_p is not responding"
-               fi
+       if [ -z "$1" ] ; then
+               echo "INTERNAL ERROR: ctdb_check_tcp_ports - no ports specified"
+               exit 1
+       fi
 
-               return 1
-               ;;
-           98)
-               # Couldn't bind, something already listening, next port...
-               continue
-               ;;
-           *)
-               echo "ERROR: unexpected error running \"ctdb checktcpport\""
-               debug <<EOF
-ctdb checktcpport (exited with $_ret) with output:
-$_out"
-EOF
-               return $_ret
-       esac
-    done
+       for _p ; do  # process each function argument (port)
+               _cmd="$CTDB checktcpport $_p"
+               _out=$($_cmd 2>&1)
+               _ret=$?
+               case "$_ret" in
+               0)
+                       echo "$service_name not listening on TCP port $_p"
+                       return 1
+                       ;;
+               98)
+                       # Couldn't bind, something already listening, next port
+                       continue
+                       ;;
+               *)
+                       echo "unexpected error (${_ret}) running \"${_cmd}\""
+                       if [ -n "$_out" ] ; then
+                               echo "$_out"
+                       fi
+                       return $_ret
+                       ;;
+               esac
+       done
 
-    # All ports listening
-    _ctdb_check_tcp_common
-    rm -f "$_ctdb_service_started_file"
-    return 0
+       # All ports listening
+       return 0
 }
 
 ######################################################
 # check a unix socket
-# usage: ctdb_check_unix_socket SERVICE_NAME <socket_path>
+# usage: ctdb_check_unix_socket SOCKPATH
 ######################################################
-ctdb_check_unix_socket() {
-    socket_path="$1"
-    [ -z "$socket_path" ] && return
+ctdb_check_unix_socket()
+{
+       _sockpath="$1"
 
-    if ! netstat --unix -a -n | grep -q "^unix.*LISTEN.*${socket_path}$"; then
-        echo "ERROR: $service_name socket $socket_path not found"
-        return 1
-    fi
-}
+       if [ -z "$_sockpath" ] ; then
+               echo "ERROR: ctdb_check_unix_socket() requires socket path"
+               return 1
+       fi
 
-######################################################
-# check a command returns zero status
-# usage: ctdb_check_command <command>
-######################################################
-ctdb_check_command ()
-{
-    _out=$("$@" 2>&1) || {
-       echo "ERROR: $* returned error"
-       echo "$_out" | debug
-       exit 1
-    }
+       _out=$(ss -l -x "src ${_sockpath}" | tail -n +2)
+       if [ -z "$_out" ] ; then
+               echo "ERROR: ${service_name} not listening on ${_sockpath}"
+               return 1
+       fi
 }
 
 ################################################
@@ -781,10 +420,11 @@ ctdb_check_command ()
 ################################################
 kill_tcp_connections ()
 {
-    _ip="$1"
+    _iface="$1"
+    _ip="$2"
 
     _oneway=false
-    if [ "$2" = "oneway" ] ; then
+    if [ "$3" = "oneway" ] ; then
        _oneway=true
     fi
 
@@ -801,42 +441,40 @@ kill_tcp_connections ()
                139|445) __oneway=true ;;
            esac
 
-           echo "Killing TCP connection $_src $_dst"
            _connections="${_connections}${_nl}${_src} ${_dst}"
            if ! $__oneway ; then
                _connections="${_connections}${_nl}${_dst} ${_src}"
            fi
 
-           _killcount=$(($_killcount + 1))
+           _killcount=$((_killcount + 1))
        done
 
        if [ $_killcount -eq 0 ] ; then
            return
        fi
 
-       echo "$_connections" | ctdb killtcp || {
-           echo "Failed to send killtcp control"
-           return
+       echo "$_connections" | \
+               "${CTDB_HELPER_BINDIR}/ctdb_killtcp" "$_iface" || {
+               echo "Failed to kill TCP connections"
+               return
        }
 
-       _count=0
-       while : ; do
-           _remaining=$(get_tcp_connections_for_ip $_ip | wc -l)
+       _connections=$(get_tcp_connections_for_ip "$_ip")
+       if [ -z "$_connections" ] ; then
+               _remaining=0
+       else
+               _remaining=$(echo "$_connections" | wc -l)
+       fi
 
-           if [ $_remaining -eq 0 ] ; then
-               echo "Killed $_killcount TCP connections to released IP $_ip"
-               return
-           fi
+       _actually_killed=$((_killcount - _remaining))
 
-           _count=$(($_count + 1))
-           if [ $_count -gt 3 ] ; then
-               echo "Timed out killing tcp connections for IP $_ip ($_remaining remaining)"
-               return
-           fi
+       _t="${_actually_killed}/${_killcount}"
+       echo "Killed ${_t} TCP connections to released IP $_ip"
 
-           echo "Waiting for $_remaining connections to be killed for IP $_ip"
-           sleep 1
-       done
+       if [ -n "$_connections" ] ; then
+               echo "Remaining connections:"
+               echo "$_connections" | sed -e 's|^|  |'
+       fi
     }
 }
 
@@ -845,7 +483,7 @@ kill_tcp_connections ()
 ##################################################################
 kill_tcp_connections_local_only ()
 {
-    kill_tcp_connections "$1" "oneway"
+    kill_tcp_connections "$@" "oneway"
 }
 
 ##################################################################
@@ -855,195 +493,19 @@ tickle_tcp_connections ()
 {
     _ip="$1"
 
-    get_tcp_connections_for_ip "$_ip" |
-    {
-       _failed=false
+    # Get connections, both directions
+    _conns=$(get_tcp_connections_for_ip "$_ip" | \
+                   awk '{ print $1, $2 ; print $2, $1 }')
 
-       while read dest src; do
-           echo "Tickle TCP connection $src $dest"
-           ctdb tickle $src $dest >/dev/null 2>&1 || _failed=true
-           echo "Tickle TCP connection $dest $src"
-           ctdb tickle $dest $src >/dev/null 2>&1 || _failed=true
-       done
-
-       if $_failed ; then
-           echo "Failed to send tickle control"
-       fi
-    }
+    echo "$_conns" | awk '{ print "Tickle TCP connection", $1, $2 }'
+    echo "$_conns" | ctdb tickle
 }
 
 get_tcp_connections_for_ip ()
 {
     _ip="$1"
 
-    netstat -tn | awk -v ip=$_ip \
-       'index($1, "tcp") == 1 && \
-        (index($4, ip ":") == 1 || index($4, "::ffff:" ip ":") == 1) \
-        && $6 == "ESTABLISHED" \
-        {print $4" "$5}'
-}
-
-##################################################################
-# use statd-callout to update NFS lock info
-##################################################################
-nfs_update_lock_info ()
-{
-    if [ -x "$CTDB_BASE/statd-callout" ] ; then
-       "$CTDB_BASE/statd-callout" update
-    fi
-}
-
-########################################################
-# start/stop the Ganesha nfs service
-########################################################
-startstop_ganesha()
-{
-    _service_name="nfs-ganesha-$CTDB_CLUSTER_FILESYSTEM_TYPE"
-    case "$1" in
-       start)
-           service "$_service_name" start
-           ;;
-       stop)
-           service "$_service_name" stop
-           ;;
-       restart)
-           service "$_service_name" stop
-           nfs_dump_some_threads "rpc.statd"
-           service "$_service_name" start
-           ;;
-    esac
-}
-
-########################################################
-# start/stop the nfs service on different platforms
-########################################################
-startstop_nfs() {
-       PLATFORM="unknown"
-       [ -x $CTDB_ETCDIR/init.d/nfsserver ] && {
-               PLATFORM="sles"
-       }
-       [ -x $CTDB_ETCDIR/init.d/nfslock -o \
-           -r /usr/lib/systemd/system/nfs-lock.service ] && {
-               PLATFORM="rhel"
-       }
-
-       case $PLATFORM in
-       sles)
-               case $1 in
-               start)
-                       service nfsserver start
-                       ;;
-               stop)
-                       service nfsserver stop > /dev/null 2>&1
-                       ;;
-               restart)
-                       set_proc "fs/nfsd/threads" 0
-                       service nfsserver stop > /dev/null 2>&1
-                       pkill -9 nfsd
-                       nfs_dump_some_threads
-                       service nfsserver start
-                       ;;
-               restart-stop)
-                       set_proc "fs/nfsd/threads" 0
-                       service nfsserver stop > /dev/null 2>&1
-                       pkill -9 nfsd
-                       ;;
-               esac
-               ;;
-       rhel)
-               case $1 in
-               start)
-                       service nfslock start
-                       service nfs start
-                       ;;
-               stop)
-                       service nfs stop
-                       service nfslock stop
-                       ;;
-               restart)
-                       set_proc "fs/nfsd/threads" 0
-                       service nfs stop > /dev/null 2>&1
-                       service nfslock stop > /dev/null 2>&1
-                       pkill -9 nfsd
-                       nfs_dump_some_threads
-                       service nfslock start
-                       service nfs start
-                       ;;
-               restart-stop)
-                       set_proc "fs/nfsd/threads" 0
-                       service nfs stop > /dev/null 2>&1
-                       service nfslock stop > /dev/null 2>&1
-                       pkill -9 nfsd
-                       ;;
-               esac
-               ;;
-       *)
-               echo "Unknown platform. NFS is not supported with ctdb"
-               exit 1
-               ;;
-       esac
-}
-
-# Dump up to the configured number of nfsd thread backtraces.
-nfs_dump_some_threads ()
-{
-    _prog="${1:-nfsd}"
-
-    _num="${CTDB_NFS_DUMP_STUCK_THREADS:-5}"
-    [ $_num -gt 0 ] || return 0
-
-    program_stack_traces "$_prog" $_num
-}
-
-########################################################
-# start/stop the nfs lockmanager service on different platforms
-########################################################
-startstop_nfslock() {
-       PLATFORM="unknown"
-       [ -x $CTDB_ETCDIR/init.d/nfsserver ] && {
-               PLATFORM="sles"
-       }
-       [ -x $CTDB_ETCDIR/init.d/nfslock -o \
-           -r /usr/lib/systemd/system/nfs-lock.service ] && {
-               PLATFORM="rhel"
-       }
-
-       case $PLATFORM in
-       sles)
-               # for sles there is no service for lockmanager
-               # so we instead just shutdown/restart nfs
-               case $1 in
-               start)
-                       service nfsserver start
-                       ;;
-               stop)
-                       service nfsserver stop > /dev/null 2>&1
-                       ;;
-               restart)
-                       service nfsserver stop > /dev/null 2>&1
-                       service nfsserver start
-                       ;;
-               esac
-               ;;
-       rhel)
-               case $1 in
-               start)
-                       service nfslock start
-                       ;;
-               stop)
-                       service nfslock stop > /dev/null 2>&1
-                       ;;
-               restart)
-                       service nfslock stop > /dev/null 2>&1
-                       service nfslock start
-                       ;;
-               esac
-               ;;
-       *)
-               echo "Unknown platform. NFS locking is not supported with ctdb"
-               exit 1
-               ;;
-       esac
+    ss -tn state established "src [$_ip]" | awk 'NR > 1 {print $3, $4}'
 }
 
 ########################################################
@@ -1059,11 +521,13 @@ add_ip_to_iface ()
        die "Failed to bringup interface $_iface"
 
     # Only need to define broadcast for IPv4
-    case "$ip" in
+    case "$_ip" in
         *:*) _bcast=""      ;;
        *)   _bcast="brd +" ;;
     esac
 
+    # Intentionally unquoted multi-word value here
+    # shellcheck disable=SC2086
     ip addr add "$_ip/$_maskbits" $_bcast dev "$_iface" || {
        echo "Failed to add $_ip/$_maskbits on dev $_iface"
        return 1
@@ -1118,36 +582,38 @@ ip_maskbits_iface ()
     _addr="$1"
 
     case "$_addr" in
-       *:*) _family="inet6" ; _bits=128 ;;
-       *)   _family="inet"  ; _bits=32  ;;
+       *:*) _bits=128 ;;
+       *)   _bits=32  ;;
     esac
-
     ip addr show to "${_addr}/${_bits}" 2>/dev/null | \
-       awk -v family="${_family}" \
-           'NR == 1 { iface = $2; sub(":$", "", iface) ; \
-                      sub("@.*", "", iface) } \
-             $1 ~ /inet/ { mask = $2; sub(".*/", "", mask); \
-                           print mask, iface, family }'
+       awk 'NR == 1 { iface = $2; sub(":$", "", iface) ;
+                      sub("@.*", "", iface) }
+             $1 ~ /inet/ { mask = $2; sub(".*/", "", mask);
+                           print mask, iface }'
 }
 
 drop_ip ()
 {
     _addr="${1%/*}"  # Remove optional maskbits
 
-    set -- $(ip_maskbits_iface $_addr)
+    # Intentional word splitting here
+    # shellcheck disable=SC2046
+    set -- $(ip_maskbits_iface "$_addr")
     if [ -n "$1" ] ; then
        _maskbits="$1"
        _iface="$2"
        echo "Removing public address $_addr/$_maskbits from device $_iface"
-       delete_ip_from_iface $_iface $_addr $_maskbits >/dev/null 2>&1
+       delete_ip_from_iface "$_iface" "$_addr" "$_maskbits" >/dev/null 2>&1
     fi
 }
 
 drop_all_public_ips ()
 {
-    while read _ip _x ; do
-       drop_ip "$_ip"
-    done <"${CTDB_PUBLIC_ADDRESSES:-/dev/null}"
+       # _x is intentionally ignored
+       # shellcheck disable=SC2034
+       while read _ip _x ; do
+               drop_ip "$_ip"
+       done <"${CTDB_BASE}/public_addresses"
 }
 
 flush_route_cache ()
@@ -1157,134 +623,151 @@ flush_route_cache ()
 }
 
 ########################################################
-# Simple counters
-_ctdb_counter_common () {
-    _service_name="${1:-${service_name:-${script_name}}}"
-    _counter_file="$ctdb_fail_dir/$_service_name"
-    mkdir -p "${_counter_file%/*}" # dirname
+# Interface monitoring
+
+# If the interface is a virtual one (e.g. VLAN) then get the
+# underlying interface
+interface_get_real ()
+{
+    # Output of "ip link show <iface>"
+    _iface_info="$1"
+
+    # Extract the full interface description to see if it is a VLAN
+    _t=$(echo "$_iface_info" |
+               awk 'NR == 1 { iface = $2; sub(":$", "", iface) ;
+                              print iface }')
+    case "$_t" in
+       *@*)
+           # VLAN: use the underlying interface, after the '@'
+           echo "${_t##*@}"
+           ;;
+       *)
+           # Not a regular VLAN.  For backward compatibility, assume
+           # there is some other sort of VLAN that doesn't have the
+           # '@' in the output and only use what is before a '.'.  If
+           # there is no '.' then this will be the whole interface
+           # name.
+           echo "${_t%%.*}"
+    esac
 }
-ctdb_counter_init () {
-    _ctdb_counter_common "$1"
 
-    >"$_counter_file"
-}
-ctdb_counter_incr () {
-    _ctdb_counter_common "$1"
+# Check whether an interface is operational
+interface_monitor ()
+{
+    _iface="$1"
 
-    # unary counting!
-    echo -n 1 >> "$_counter_file"
-}
-ctdb_counter_get () {
-    _ctdb_counter_common "$1"
-    # unary counting!
-    stat -c "%s" "$_counter_file" 2>/dev/null || echo 0
-}
-ctdb_check_counter () {
-    _msg="${1:-error}"  # "error"  - anything else is silent on fail
-    _op="${2:--ge}"  # an integer operator supported by test
-    _limit="${3:-${service_fail_limit}}"
-    shift 3
-
-    _size=$(ctdb_counter_get "$1")
-
-    _hit=false
-    if [ "$_op" != "%" ] ; then
-       if [ $_size $_op $_limit ] ; then
-           _hit=true
-       fi
-    else
-       if [ $(($_size $_op $_limit)) -eq 0 ] ; then
-           _hit=true
-       fi
-    fi
-    if $_hit ; then
-       if [ "$_msg" = "error" ] ; then
-           echo "ERROR: $_size consecutive failures for $_service_name, marking node unhealthy"
-           exit 1              
-       else
+    _iface_info=$(ip link show "$_iface" 2>&1) || {
+       echo "ERROR: Monitored interface ${_iface} does not exist"
+       return 1
+    }
+
+
+    # If the interface is a virtual one (e.g. VLAN) then get the
+    # underlying interface.
+    _realiface=$(interface_get_real "$_iface_info")
+
+    if _bi=$(get_proc "net/bonding/${_realiface}" 2>/dev/null) ; then
+       # This is a bond: various monitoring strategies
+       echo "$_bi" | grep -q 'Currently Active Slave: None' && {
+           echo "ERROR: No active slaves for bond device ${_realiface}"
            return 1
-       fi
+       }
+       echo "$_bi" | grep -q '^MII Status: up' || {
+           echo "ERROR: public network interface ${_realiface} is down"
+           return 1
+       }
+       echo "$_bi" | grep -q '^Bonding Mode: IEEE 802.3ad Dynamic link aggregation' && {
+           # This works around a bug in the driver where the
+           # overall bond status can be up but none of the actual
+           # physical interfaces have a link.
+           echo "$_bi" | grep 'MII Status:' | tail -n +2 | grep -q '^MII Status: up' || {
+               echo "ERROR: No active slaves for 802.ad bond device ${_realiface}"
+               return 1
+           }
+       }
+
+       return 0
+    else
+       # Not a bond
+       case "$_iface" in
+           lo*)
+               # loopback is always working
+               return 0
+               ;;
+           ib*)
+               # we don't know how to test ib links
+               return 0
+               ;;
+           *)
+               ethtool "$_iface" | grep -q 'Link detected: yes' || {
+                   # On some systems, this is not successful when a
+                   # cable is plugged but the interface has not been
+                   # brought up previously. Bring the interface up
+                   # and try again...
+                   ip link set "$_iface" up
+                   ethtool "$_iface" | grep -q 'Link detected: yes' || {
+                       echo "ERROR: No link on the public network interface ${_iface}"
+                       return 1
+                   }
+               }
+               return 0
+               ;;
+       esac
     fi
 }
 
 ########################################################
-
-ctdb_status_dir="$CTDB_VARDIR/state/service_status"
-ctdb_fail_dir="$CTDB_VARDIR/state/failcount"
-
-ctdb_setup_service_state_dir ()
+# Simple counters
+_ctdb_counter_common ()
 {
-    service_state_dir="$CTDB_VARDIR/state/service_state/${1:-${service_name}}"
-    mkdir -p "$service_state_dir" || {
-       echo "Error creating state dir \"$service_state_dir\""
-       exit 1
-    }
-}
+       [ $# -le 1 ] || die "usage: _ctdb_counter_common [name]"
 
-########################################################
-# Managed status history, for auto-start/stop
+       if [ $# -eq 1 ] ; then
+               _counter_name="${1}.failcount"
+       else
+               _counter_name="failcount"
+       fi
 
-ctdb_managed_dir="$CTDB_VARDIR/state/managed_history"
+       if [ -z "$script_state_dir" ] ; then
+               die "ctdb_counter_* functions need ctdb_setup_state_dir()"
+       fi
 
-_ctdb_managed_common ()
-{
-    _ctdb_managed_file="$ctdb_managed_dir/$service_name"
+       _counter_file="${script_state_dir}/${_counter_name}"
 }
+# Some code passes an argument
+# shellcheck disable=SC2120
+ctdb_counter_init () {
+    _ctdb_counter_common "$1"
 
-ctdb_service_managed ()
-{
-    _ctdb_managed_common
-    mkdir -p "$ctdb_managed_dir"
-    touch "$_ctdb_managed_file"
+    : >"$_counter_file"
 }
+ctdb_counter_incr () {
+    _ctdb_counter_common "$1"
 
-ctdb_service_unmanaged ()
-{
-    _ctdb_managed_common
-    rm -f "$_ctdb_managed_file"
+    # unary counting using newlines!
+    echo >>"$_counter_file"
 }
-
-is_ctdb_previously_managed_service ()
-{
-    _ctdb_managed_common
-    [ -f "$_ctdb_managed_file" ]
+ctdb_counter_get () {
+    _ctdb_counter_common "$1"
+    # unary counting!
+    stat -c "%s" "$_counter_file" 2>/dev/null || echo 0
 }
 
 ########################################################
-# Check and set status
 
-log_status_cat ()
+# ctdb_setup_state_dir <type> <name>
+#   Sets/creates script_state_dir)
+ctdb_setup_state_dir ()
 {
-    echo "node is \"$1\", \"${script_name}\" reports problem: $(cat $2)"
-}
+       [ $# -eq 2 ] || die "usage: ctdb_setup_state_dir <type> <name>"
 
-ctdb_checkstatus ()
-{
-    if [ -r "$ctdb_status_dir/$script_name/unhealthy" ] ; then
-       log_status_cat "unhealthy" "$ctdb_status_dir/$script_name/unhealthy"
-       return 1
-    elif [ -r "$ctdb_status_dir/$script_name/banned" ] ; then
-       log_status_cat "banned" "$ctdb_status_dir/$script_name/banned"
-       return 2
-    else
-       return 0
-    fi
-}
+       _type="$1"
+       _name="$2"
 
-ctdb_setstatus ()
-{
-    d="$ctdb_status_dir/$script_name"
-    case "$1" in
-       unhealthy|banned)
-           mkdir -p "$d"
-           cat "$2" >"$d/$1"
-           ;;
-       *)
-           for i in "banned" "unhealthy" ; do
-               rm -f "$d/$i"
-           done
-           ;;
-    esac
+       script_state_dir="${CTDB_SCRIPT_VARDIR}/${_type}/${_name}"
+
+       mkdir -p "$script_state_dir" || \
+               die "Error creating script state dir \"${script_state_dir}\""
 }
 
 ##################################################################
@@ -1292,9 +775,11 @@ ctdb_setstatus ()
 
 _ctdb_service_reconfigure_common ()
 {
-    _d="$ctdb_status_dir/${service_name}"
-    mkdir -p "$_d"
-    _ctdb_service_reconfigure_flag="$_d/reconfigure"
+       if [ -z "$script_state_dir" ] ; then
+               die "ctdb_service_*_reconfigure() needs ctdb_setup_state_dir()"
+       fi
+
+       _ctdb_service_reconfigure_flag="${script_state_dir}/need_reconfigure"
 }
 
 ctdb_service_needs_reconfigure ()
@@ -1306,7 +791,7 @@ ctdb_service_needs_reconfigure ()
 ctdb_service_set_reconfigure ()
 {
     _ctdb_service_reconfigure_common
-    >"$_ctdb_service_reconfigure_flag"
+    >"$_ctdb_service_reconfigure_flag"
 }
 
 ctdb_service_unset_reconfigure ()
@@ -1320,6 +805,8 @@ ctdb_service_reconfigure ()
     echo "Reconfiguring service \"${service_name}\"..."
     ctdb_service_unset_reconfigure
     service_reconfigure || return $?
+    # Intentionally have this use $service_name as default
+    # shellcheck disable=SC2119
     ctdb_counter_init
 }
 
@@ -1329,244 +816,8 @@ service_reconfigure ()
     :
 }
 
-ctdb_reconfigure_take_lock ()
-{
-    _ctdb_service_reconfigure_common
-    _lock="${_d}/reconfigure_lock"
-    mkdir -p "${_lock%/*}" # dirname
-    touch "$_lock"
-
-    (
-       flock 0
-       # This is overkill but will work if we need to extend this to
-       # allow certain events to run multiple times in parallel
-       # (e.g. takeip) and write multiple PIDs to the file.
-       read _locker_event 
-       if [ -n "$_locker_event" ] ; then
-           while read _pid ; do
-               if [ -n "$_pid" -a "$_pid" != $$ ] && \
-                   kill -0 "$_pid" 2>/dev/null ; then
-                   exit 1
-               fi
-           done
-       fi
-
-       printf "%s\n%s\n" "$event_name" $$ >"$_lock"
-       exit 0
-    ) <"$_lock"
-}
-
-ctdb_reconfigure_release_lock ()
-{
-    _ctdb_service_reconfigure_common
-    _lock="${_d}/reconfigure_lock"
-
-    rm -f "$_lock"
-}
-
-ctdb_replay_monitor_status ()
-{
-    echo "Replaying previous status for this script due to reconfigure..."
-    # Leading separator ('|') is missing in some versions...
-    _out=$(ctdb scriptstatus -X | grep -E "^\|?monitor\|${script_name}\|")
-    # Output looks like this:
-    # |monitor|60.nfs|1|ERROR|1314764004.030861|1314764004.035514|foo bar|
-    # This is the cheapest way of getting fields in the middle.
-    set -- $(IFS="|" ; echo $_out)
-    _code="$3"
-    _status="$4"
-    # The error output field can include colons so we'll try to
-    # preserve them.  The weak checking at the beginning tries to make
-    # this work for both broken (no leading '|') and fixed output.
-    _out="${_out%|}"
-    _err_out="${_out#*monitor|${script_name}|*|*|*|*|}"
-    case "$_status" in
-       OK) : ;;  # Do nothing special.
-       TIMEDOUT)
-           # Recast this as an error, since we can't exit with the
-           # correct negative number.
-           _code=1
-           _err_out="[Replay of TIMEDOUT scriptstatus - note incorrect return code.] ${_err_out}"
-           ;;
-       DISABLED)
-           # Recast this as an OK, since we can't exit with the
-           # correct negative number.
-           _code=0
-           _err_out="[Replay of DISABLED scriptstatus - note incorrect return code.] ${_err_out}"
-           ;;
-       *) : ;;  # Must be ERROR, do nothing special.
-    esac
-    if [ -n "$_err_out" ] ; then
-       echo "$_err_out"
-    fi
-    exit $_code
-}
-
-ctdb_service_check_reconfigure ()
-{
-    assert_service_name
-
-    # We only care about some events in this function.  For others we
-    # return now.
-    case "$event_name" in
-       monitor|ipreallocated|reconfigure) : ;;
-       *) return 0 ;;
-    esac
-
-    if ctdb_reconfigure_take_lock ; then
-       # No events covered by this function are running, so proceed
-       # with gay abandon.
-       case "$event_name" in
-           reconfigure)
-               (ctdb_service_reconfigure)
-               exit $?
-               ;;
-           ipreallocated)
-               if ctdb_service_needs_reconfigure ; then
-                   ctdb_service_reconfigure
-               fi
-               ;;
-       esac
-
-       ctdb_reconfigure_release_lock
-    else
-       # Somebody else is running an event we don't want to collide
-       # with.  We proceed with caution.
-       case "$event_name" in
-           reconfigure)
-               # Tell whoever called us to retry.
-               exit 2
-               ;;
-           ipreallocated)
-               # Defer any scheduled reconfigure and just run the
-               # rest of the ipreallocated event, as per the
-               # eventscript.  There's an assumption here that the
-               # event doesn't depend on any scheduled reconfigure.
-               # This is true in the current code.
-               return 0
-               ;;
-           monitor)
-               # There is most likely a reconfigure in progress so
-               # the service is possibly unstable.  As above, we
-               # defer any scheduled reconfigured.  We also replay
-               # the previous monitor status since that's the best
-               # information we have.
-               ctdb_replay_monitor_status
-               ;;
-       esac
-    fi
-}
-
-##################################################################
-# Does CTDB manage this service? - and associated auto-start/stop
-
-ctdb_compat_managed_service ()
-{
-    if [ "$1" = "yes" -a "$2" = "$service_name" ] ; then
-       CTDB_MANAGED_SERVICES="$CTDB_MANAGED_SERVICES $2"
-    fi
-}
-
-is_ctdb_managed_service ()
-{
-    assert_service_name
-
-    # $t is used just for readability and to allow better accurate
-    # matching via leading/trailing spaces
-    t=" $CTDB_MANAGED_SERVICES "
-
-    # Return 0 if "<space>$service_name<space>" appears in $t
-    if [ "${t#* ${service_name} }" != "${t}" ] ; then
-       return 0
-    fi
-
-    # If above didn't match then update $CTDB_MANAGED_SERVICES for
-    # backward compatibility and try again.
-    ctdb_compat_managed_service "$CTDB_MANAGES_VSFTPD"   "vsftpd"
-    ctdb_compat_managed_service "$CTDB_MANAGES_SAMBA"    "samba"
-    ctdb_compat_managed_service "$CTDB_MANAGES_WINBIND"  "winbind"
-    ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD"    "apache2"
-    ctdb_compat_managed_service "$CTDB_MANAGES_HTTPD"    "httpd"
-    ctdb_compat_managed_service "$CTDB_MANAGES_ISCSI"    "iscsi"
-    ctdb_compat_managed_service "$CTDB_MANAGES_CLAMD"    "clamd"
-    ctdb_compat_managed_service "$CTDB_MANAGES_NFS"      "nfs"
-    ctdb_compat_managed_service "$CTDB_MANAGES_NFS"      "nfs-ganesha-gpfs"
-
-    t=" $CTDB_MANAGED_SERVICES "
-
-    # Return 0 if "<space>$service_name<space>" appears in $t
-    [ "${t#* ${service_name} }" != "${t}" ]
-}
-
-ctdb_start_stop_service ()
-{
-    assert_service_name
-
-    # Allow service-start/service-stop pseudo-events to start/stop
-    # services when we're not auto-starting/stopping and we're not
-    # monitoring.
-    case "$event_name" in
-       service-start)
-           if is_ctdb_managed_service ; then
-               die 'service-start event not permitted when service is managed'
-           fi
-           if [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] ; then
-               die 'service-start event not permitted with $CTDB_SERVICE_AUTOSTARTSTOP = yes'
-           fi
-           ctdb_service_start
-           exit $?
-           ;;
-       service-stop)
-           if is_ctdb_managed_service ; then
-               die 'service-stop event not permitted when service is managed'
-           fi
-           if [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] ; then
-               die 'service-stop event not permitted with $CTDB_SERVICE_AUTOSTARTSTOP = yes'
-           fi
-           ctdb_service_stop
-           exit $?
-           ;;
-    esac
-
-    # Do nothing unless configured to...
-    [ "$CTDB_SERVICE_AUTOSTARTSTOP" = "yes" ] || return 0
-
-    [ "$event_name" = "monitor" ] || return 0
-
-    if is_ctdb_managed_service ; then
-       if ! is_ctdb_previously_managed_service ; then
-           echo "Starting service \"$service_name\" - now managed"
-           background_with_logging ctdb_service_start
-           exit $?
-       fi
-    else
-       if is_ctdb_previously_managed_service ; then
-           echo "Stopping service \"$service_name\" - no longer managed"
-           background_with_logging ctdb_service_stop
-           exit $?
-       fi
-    fi
-}
-
-ctdb_service_start ()
-{
-    # The service is marked managed if we've ever tried to start it.
-    ctdb_service_managed
-
-    service_start || return $?
-
-    ctdb_counter_init
-    ctdb_check_tcp_init
-}
-
-ctdb_service_stop ()
-{
-    ctdb_service_unmanaged
-    service_stop
-}
-
 # Default service_start() and service_stop() functions.
+
 # These may be overridden in an eventscript.
 service_start ()
 {
@@ -1580,19 +831,11 @@ service_stop ()
 
 ##################################################################
 
+# This exists only for backward compatibility with 3rd party scripts
+# that call it
 ctdb_standard_event_handler ()
 {
-    case "$1" in
-       status)
-           ctdb_checkstatus
-           exit
-           ;;
-       setstatus)
-            shift
-           ctdb_setstatus "$@"
-           exit
-           ;;
-    esac
+    :
 }
 
 iptables_wrapper ()
@@ -1605,10 +848,12 @@ iptables_wrapper ()
     fi
 
     # iptables doesn't like being re-entered, so flock-wrap it.
-    flock -w 30 "${CTDB_VARDIR}/iptables-ctdb.flock" "$_iptables_cmd" "$@"
+    flock -w 30 "${CTDB_SCRIPT_VARDIR}/iptables.flock" "$_iptables_cmd" "$@"
 }
 
 # AIX (and perhaps others?) doesn't have mktemp
+# type is commonly supported and more portable than which(1)
+# shellcheck disable=SC2039
 if ! type mktemp >/dev/null 2>&1 ; then
     mktemp ()
     {
@@ -1627,13 +872,78 @@ if ! type mktemp >/dev/null 2>&1 ; then
            if $_dir ; then
                mkdir "$_t"
            else
-               >"$_t"
+               >"$_t"
            fi
        )
        echo "$_t"
     }
 fi
 
+######################################################################
+# NFS callout handling
+
+nfs_callout_init ()
+{
+       _state_dir="$1"
+
+       if [ -z "$CTDB_NFS_CALLOUT" ] ; then
+               CTDB_NFS_CALLOUT="${CTDB_BASE}/nfs-linux-kernel-callout"
+       fi
+       # Always export, for statd callout
+       export CTDB_NFS_CALLOUT
+
+       # If the callout wants to use this then it must create it
+       export CTDB_NFS_CALLOUT_STATE_DIR="${_state_dir}/callout-state"
+
+       # Export, if set, for use by clustered NFS callouts
+       if [ -n "$CTDB_NFS_STATE_FS_TYPE" ] ; then
+               export CTDB_NFS_STATE_FS_TYPE
+       fi
+       if [ -n "$CTDB_NFS_STATE_MNT" ] ; then
+               export CTDB_NFS_STATE_MNT
+       fi
+
+       nfs_callout_cache="${_state_dir}/nfs_callout_cache"
+       nfs_callout_cache_callout="${nfs_callout_cache}/CTDB_NFS_CALLOUT"
+       nfs_callout_cache_ops="${nfs_callout_cache}/ops"
+}
+
+nfs_callout_register ()
+{
+    mkdir -p "$nfs_callout_cache_ops"
+    rm -f "$nfs_callout_cache_ops"/*
+
+    echo "$CTDB_NFS_CALLOUT" >"$nfs_callout_cache_callout"
+
+    _t=$(eval "$CTDB_NFS_CALLOUT" "register")
+    if [ -n "$_t" ] ; then
+       echo "$_t" |
+           while IFS="" read _op ; do
+               touch "${nfs_callout_cache_ops}/${_op}"
+           done
+    else
+       touch "${nfs_callout_cache_ops}/ALL"
+    fi
+}
+
+nfs_callout ()
+{
+    # Re-run registration if $CTDB_NFS_CALLOUT has changed
+    _prev=""
+    if [ -r "$nfs_callout_cache_callout" ] ; then
+       read _prev <"$nfs_callout_cache_callout"
+    fi
+    if [ "$CTDB_NFS_CALLOUT" != "$_prev" ] ; then
+       nfs_callout_register
+    fi
+
+    # Run the operation if it is registered...
+    if [ -e "${nfs_callout_cache_ops}/${1}" ] || \
+          [ -e "${nfs_callout_cache_ops}/ALL" ]; then
+       eval "$CTDB_NFS_CALLOUT" "$@"
+    fi
+}
+
 ########################################################
 # tickle handling
 ########################################################
@@ -1642,67 +952,69 @@ update_tickles ()
 {
        _port="$1"
 
-       tickledir="$CTDB_VARDIR/state/tickles"
+       tickledir="${CTDB_SCRIPT_VARDIR}/tickles"
        mkdir -p "$tickledir"
 
-       ctdb_get_pnn
-
        # What public IPs do I hold?
-       _ips=$(ctdb -X ip | awk -F'|' -v pnn=$pnn '$3 == pnn {print $2}')
-
-       # IPs as a regexp choice
-       _ipschoice="($(echo $_ips | sed -e 's/ /|/g' -e 's/\./\\\\./g'))"
+       _pnn=$(ctdb_get_pnn)
+       _ips=$($CTDB -X ip | awk -F'|' -v pnn="$_pnn" '$3 == pnn {print $2}')
 
-       # Record connections to our public IPs in a temporary file
-       _my_connections="${tickledir}/${_port}.connections"
-       rm -f "$_my_connections"
-       netstat -tn |
-       awk -v destpat="^${_ipschoice}:${_port}\$" \
-         '$1 == "tcp" && $6 == "ESTABLISHED" && $4 ~ destpat {print $5, $4}' |
+       # IPs and port as ss filters
+       _ip_filter=""
+       for _ip in $_ips ; do
+           _ip_filter="${_ip_filter}${_ip_filter:+ || }src [${_ip}]"
+       done
+       _port_filter="sport == :${_port}"
+
+       # Record connections to our public IPs in a temporary file.
+       # This temporary file is in CTDB's private state directory and
+       # $$ is used to avoid a very rare race involving CTDB's script
+       # debugging.  No security issue, nothing to see here...
+       _my_connections="${tickledir}/${_port}.connections.$$"
+       # Parentheses are needed around the filters for precedence but
+       # the parentheses can't be empty!
+       ss -tn state established \
+          "${_ip_filter:+( ${_ip_filter} )}" \
+          "${_port_filter:+( ${_port_filter} )}" |
+       awk 'NR > 1 {print $4, $3}' |
        sort >"$_my_connections"
 
        # Record our current tickles in a temporary file
-       _my_tickles="${tickledir}/${_port}.tickles"
-       rm -f "$_my_tickles"
+       _my_tickles="${tickledir}/${_port}.tickles.$$"
        for _i in $_ips ; do
-               ctdb -X gettickles $_i $_port |
+               $CTDB -X gettickles "$_i" "$_port" |
                awk -F'|' 'NR > 1 { printf "%s:%s %s:%s\n", $2, $3, $4, $5 }'
        done |
        sort >"$_my_tickles"
 
        # Add tickles for connections that we haven't already got tickles for
-       comm -23 "$_my_connections" "$_my_tickles" |
-       while read _src _dst ; do
-               ctdb addtickle $_src $_dst
-       done
+       comm -23 "$_my_connections" "$_my_tickles" | \
+               $CTDB addtickle
 
        # Remove tickles for connections that are no longer there
-       comm -13 "$_my_connections" "$_my_tickles" |
-       while read _src _dst ; do
-               ctdb deltickle $_src $_dst
-       done
+       comm -13 "$_my_connections" "$_my_tickles" | \
+               $CTDB deltickle
+
+       rm -f "$_my_connections" "$_my_tickles"
 
-       rm -f "$_my_connections" "$_my_tickles" 
+       # Remove stale files from killed scripts
+       # Files can't have spaces in name, more portable than -print0/-0
+       # shellcheck disable=SC2038
+       (cd "$tickledir" && find . -type f -mmin +10 | xargs -r rm)
 }
 
 ########################################################
 # load a site local config file
 ########################################################
 
-[ -n "$CTDB_RC_LOCAL" -a -x "$CTDB_RC_LOCAL" ] && {
-       . "$CTDB_RC_LOCAL"
-}
-
-[ -x $CTDB_BASE/rc.local ] && {
-       . $CTDB_BASE/rc.local
+[ -x "${CTDB_BASE}/rc.local" ] && {
+       . "${CTDB_BASE}/rc.local"
 }
 
-[ -d $CTDB_BASE/rc.local.d ] && {
-       for i in $CTDB_BASE/rc.local.d/* ; do
+[ -d "${CTDB_BASE}/rc.local.d" ] && {
+       for i in "${CTDB_BASE}/rc.local.d"/* ; do
                [ -x "$i" ] && . "$i"
        done
 }
 
 script_name="${0##*/}"       # basename
-service_fail_limit=1
-event_name="$1"